AutoNameplates = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceConsole-2.0", "AceDB-2.0", "FuBarPlugin-2.0");
AutoNameplatesTablet = AceLibrary("Tablet-2.0");

AutoNameplatesIcon = "Interface\\Icons\\Spell_Fire_BlueImmolation"; -- This is a temporary icon, I'm just experimenting with FuBar.

AutoNameplatesOptions = {
	type = 'group',
	args = {
		enemy = {
			type = 'toggle',
			name = "Enemy",
			desc = "Show enemy nameplates when toggling?",
			get = "GetShowEnemyNameplates",
			set = "SetShowEnemyNameplates",
		},
		friend = {
			type = 'toggle',
			name = "Friend",
			desc = "Show friend nameplates when toggling?",
			get = "GetShowFriendNameplates",
			set = "SetShowFriendNameplates",
		},
	},
};

function AutoNameplates:OnInitialize()
	self:RegisterDB("AutoNameplatesDB", "AutoNameplatesDBPC");
	self:RegisterDefaults("profile", {
		showEnemyNameplates = true,
		showFriendNameplates = true,
	});

	self:RegisterChatCommand("/autonameplates", "/an", AutoNameplatesOptions);

	self.cannotDetachTooltip = true;
	self.hasNoColor = true;
	self.hasIcon = true;
	self:SetIcon(AutoNameplatesIcon);
	self.OnMenuRequest = AutoNameplatesOptions;

	self:RegisterEvent("PLAYER_REGEN_DISABLED"); -- Fires when player enters combat.
	self:RegisterEvent("PLAYER_REGEN_ENABLED"); -- Fires when the player leaves combat.
	self:Print("Loaded.");
end

function AutoNameplates:OnEnable()
end

function AutoNameplates:OnDisable()
end

function AutoNameplates:OnTooltipUpdate()
	-- Tablet structuring goes here, when I figure out how to do it how I want it.
end

function AutoNameplates:OnClick()
	-- OnClick functionality for the FuBar plugin.
end

function AutoNameplates:GetShowEnemyNameplates()
	return self.db.profile.showEnemyNameplates;
end

function AutoNameplates:GetShowFriendNameplates()
	return self.db.profile.showFriendNameplates;
end

function AutoNameplates:SetShowEnemyNameplates(v)
	self.db.profile.showEnemyNameplates = v;
end

function AutoNameplates:SetShowFriendNameplates(v)
	self.db.profile.showFriendNameplates = v;
end

function AutoNameplates:PLAYER_REGEN_DISABLED()
	if (self.db.profile.showEnemyNameplates) then
		ShowNameplates();
	end
	if (self.db.profile.showFriendNameplates) then
		ShowFriendNameplates();
	end		
end

function AutoNameplates:PLAYER_REGEN_ENABLED()
	if (self.db.profile.showEnemyNameplates) then
		HideNameplates();
	end
	if (self.db.profile.showFriendNameplates) then
		HideFriendNameplates();
	end
end